import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React, { useState } from 'react';

var withSwitchValue = function withSwitchValue(BaseComponent) {
  var displayName = BaseComponent.displayName;

  var BaseComponentWithState = function BaseComponentWithState(_ref) {
    var _ref$value = _ref.value,
        valueFromProps = _ref$value === void 0 ? false : _ref$value,
        onChangeFromProps = _ref.onChange,
        props = _objectWithoutPropertiesLoose(_ref, ["value", "onChange"]);

    var _useState = useState(Boolean(valueFromProps)),
        value = _useState[0],
        setValue = _useState[1];

    var onChange = function onChange(ev) {
      var innerValue = !value;
      var name = ev.target.name;
      setValue(innerValue);
      onChangeFromProps(ev, {
        name: name,
        value: innerValue
      });
    };

    return /*#__PURE__*/React.createElement(BaseComponent, Object.assign({}, props, {
      value: value,
      onChange: onChange
    }));
  };

  BaseComponentWithState.displayName = "withSwitchValue(" + displayName + ")";
  BaseComponentWithState.defaultProps = {
    onChange: function onChange() {}
  };
  return BaseComponentWithState;
};

export default withSwitchValue;